//LIBRERIA DE ADAFRUIT
#include <Adafruit_NeoPixel.h> //llamando libreria
#define PIN 9   //Pin entrada de Arduino
#define NUMPIXELS      60 // Número de píxels de la tira
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

//LIBRERIA DE DHT11TESTER
#include "DHT.h"
#define DHTPIN 2  
#define DHTTYPE DHT11   
DHT dht(DHTPIN, DHTTYPE);

//se declaran nombres a las entradas analógicas
const int potPinRed = A0;
const int potPinGreen = A1;
const int potPinBlue = A2;
int redColor = 0;
int greenColor = 0;
int blueColor = 0;
int i=0;
const int buttonPin = 3;    
const int ledPin = 9;
int modo = 0;

int ledState = HIGH;         
int buttonState;             
int lastButtonState = LOW;   
unsigned long lastDebounceTime = 0;  
unsigned long debounceDelay = 0; 

void setup() {
  // Inicia la libreria NeoPixel.
  pixels.begin();
  Serial.begin(9600);
  Serial.println(F("DHT11 test!"));
  dht.begin();
  pinMode(buttonPin, INPUT);
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, ledState);
}

void loop() {
 // Almacenamos el estado del actual del botón
  int reading = digitalRead(buttonPin);
  
  // Sí el estado del botón cambió, reseteamos el contador de 
  // tiempo
  if (reading != lastButtonState) {
    lastDebounceTime = millis();
  }
  
  
  if ((millis() - lastDebounceTime) > debounceDelay) {
    if (reading != buttonState) {
      Serial.println("ENTRO");
      buttonState = reading;
      
      if (buttonState == HIGH) {
        if (modo == 0) {
          modoManual();
          modo = 1;
        } else {
          modoAutomatico();
          modo = 0;
        }
      }
    }
  }
  
  lastButtonState = reading;
  
  if (modo == 0) {
    modoManual();
  } else {
    modoAutomatico();
  }
}

void modoManual(){
  
 
  //Se identifica el color de cada potenciómetro
  redColor = analogRead(potPinRed);
  greenColor = analogRead(potPinGreen); 
  blueColor = analogRead(potPinBlue);

   for (int i=0; i < NUMPIXELS; i++) {
     //cada píxel asume el color
     pixels.setPixelColor(i, pixels.Color(redColor, greenColor, blueColor));
     pixels.show();
   } 
}

void modoAutomatico(){

  // Tiempo para que el sensor lea la temrperatura
  delay(2000);
  float h = dht.readHumidity(); //Lee la humedad
  float t = dht.readTemperature(); // Lee los grados Celcius
  
  // Si hay algun error en la lectura se muestra en el monitor.
  if (isnan(h) || isnan(t)) {
    Serial.println(F("ERROR EN LA LECTURA DEL SENSOR"));
    return;
   }
   
  //Se coloca el color específico a los neopixeles para cada rango de temperatura
   
  if (t > 30){ //temperatura calurosa
    for (int i=0; i < NUMPIXELS; i++) {
     pixels.setPixelColor(i,pixels.Color(233, 63, 29));
     pixels.show();
    }
   }

  if (t < 30 && t > 25) { //temperatura tibia
    for (int i=0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(240, 131, 21));
      pixels.show();
    }
   }

  if (t < 25 && t > 19){ //temperatura fresca
    for (int i=0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(189, 255, 54));
      pixels.show();
    }
   }

  if (t < 18 && t > 15){ //temperatura templado
    for (int i=0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(64, 228, 151));
      pixels.show();
    }
   }

  if (t < 15){
    for (int i=0; i < NUMPIXELS; i++) { //temperatura frío
      pixels.setPixelColor(i, pixels.Color(189, 255, 54));
      pixels.show();
    }
   }

   // lo que se mostrará en el monitor de la lectura del sensor
   Serial.print(F("Humidity: "));
   Serial.print(h);
   Serial.print(F("%  Temperature: "));
   Serial.print(t);
   Serial.print(F("°C "));
}
 
